<?php
/*
 ---------------------------------------------
	twzServer.php v0.5

	Based on "Hosting Uptime Module" for Joomla 1.0 (see details below)
	Tweaked by tweezy to make freestanding 13-16/3/08

	For monitoring multiple servers, we tried specifying a different server name, 
	but results are patchy - depends on where the script is run. The bottom line 
	is that this script should run on the same server it is querying.
	
	Therefore there's a second script (twzServerShow.php) which is used to 
	compile results from multiple copies of this script (twzServer.php).
	
	If running this script directly, it needs online.gif and offline.gif in 
	the same directory. However it's recommended to run a single copy of
	twzServerShow.php to call this script on multiple servers. (Then online.gif 
	and offline.gif are only required by twzServerShow.php)
	
	dev@tweezy.net.au
 ---------------------------------------------
*/


//=====================================================================================
// Hosting Uptime Module 
// Created for Joomla 1.0 by Max
// Code source compliments http://www.themaxfiles.info
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// The "GNU General Public License" (GPL) is available at
// http://www.gnu.org/copyleft/gpl.html.
//=====================================================================================


//configure script
$HighLoad=5; // a server load average above this will have span class=highload so can be styled, eg bold red
$timeout = '1';
$Servername = $_SERVER['SERVER_ADDR'];

//set service checks
$port[1] = "80";       $service[1] = "Apache";                $address[1] =$Servername;
$port[2] = "21";       $service[2] = "FTP";                   $address[2] =$Servername;
$port[3] = "3306";     $service[3] = "MySQL";                 $address[3] =$Servername;
$port[4] = "25";       $service[4] = "Email(POP3)";           $address[4] =$Servername;
//$port[4] = "587"; // for POP3 on Jumba servers
$port[5] = "143";      $service[5] = "Email(IMAP)";           $address[5] =$Servername;
$port[6] = "2095";     $service[6] = "Webmail";               $address[6] =$Servername;
$port[7] = "80";       $service[7] = "External Connection";   $address[7] ="google.com";
$port[8] = "2082";     $service[8] = "cPanel";                $address[8] =$Servername;
$port[9] = "2083";     $service[9] = "cPanel SSL";            $address[9] =$Servername;

    
    
//----------------------------------------------------------------
// NO NEED TO EDIT BEYOND HERE
//

//count arrays
$ports = count($port)+1; $count = 1;
$ShowTable = !(isset($_GET['r']) and 1==$_GET['r']);

//begin table for service status..
if($ShowTable)
    {
    $data="<table width='194' border='1' cellspacing='0' cellpadding='3' style='border-style: none;' bordercolor='#333333' align='center' class='services'>\r\n";
    while($count < $ports)
        {
        if($address[$count]=="")
            { $address[$count] = ""; }

        $fp = @fsockopen("$address[$count]", $port[$count], $errno, $errstr, $timeout);
        if (!$fp) 
            {
            $data .= "\t<tr><td class='service'><b>$service[$count]</b></td><td bgcolor='#FFC6C6'><img src=offline.gif></td></tr>\r\n";
            } 
        else 
            {
            $data .= "\t<tr><td class='service'><b>$service[$count]</b></td><td bgcolor='#D9FFB3'><img src=online.gif></td></tr>\r\n";
            fclose($fp);
            }
        $count++;
        }
    $data .= "</table>\r\n";
    echo $data;
    }

//
// SERVER INFORMATION
//
//$loadresult = @exec('uptime'); // returns something like 9:40am up 9 days, 10:36, 4 users, load average: 0.02, 0.01, 0.00 _or_ 09:40:23 up 9 days, 16 min, 4 users, load average: 0.02, 0.01, 0.00
$loadresult = `uptime`; // use backticks in case exec() is disabled
preg_match("/([0-9:ampAMP]+)\s+up\s+([0-9\sdays: min,]+),\s+([0-9]+ users?),\s+load averages?:\s+([0-9\.]+),\s+([0-9\.]+),\s+([0-9\.]+)/",$loadresult,$TheResult);
$TimeNow   =$TheResult[1]; $UpTime    =$TheResult[2]; $Users     =$TheResult[3];
$Avg_1min  =$TheResult[4]; $Avg_5min  =$TheResult[5]; $Avg_15min =$TheResult[6];

if($Avg_1min >= $HighLoad) $Avg_1min="<span class='highload'>$Avg_1min</span>";
if($Avg_5min >= $HighLoad) $Avg_5min="<span class='highload'>$Avg_5min</span>";
if($Avg_15min>= $HighLoad) $Avg_15min="<span class='highload'>$Avg_15min</span>";

if($ShowTable)
    {
    // table for uptime info..
    $data="<table width='194' border='1' cellspacing='0' cellpadding='3' style='border-style: none;' bordercolor='#333333' align='center' class='server'>\r\n";
    $data .= "\t<tr><td class='lbl1'>Server Load Averages </td></tr><tr><td>$Avg_1min, $Avg_5min, $Avg_15min</td></tr>\r\n";
    $data .= "\t<tr><td class='lbl1'>Server Uptime        </td></tr><tr><td>$UpTime                         </td></tr>\r\n";
    $data .= "\t<tr><td class='lbl2'>$Users @ $TimeNow</td></tr>\r\n";
    $data .= "\t<tr><td class='lbl3'>$loadresult</td></tr>\r\n"; // this is for testing/checking the regexp (normally hidden by CSS)
    $data .= "</table>\r\n";
    }
else
    {
    // only return server load and uptime..
    //$data="$Avg_1min, $Avg_5min, $Avg_15min~$UpTime";
    $data='<div class="summ sl">'."$Avg_1min, $Avg_5min, $Avg_15min".'</div><div class="summ su">'.$UpTime.'</div>';
    }

echo $data;

?>